import { Controller } from '@a11d/lit';
import { PointerHoverController } from './PointerHoverController.js';
import { PointerPressController } from './PointerPressController.js';
import { PointerTypeController } from './PointerTypeController.js';
export class PointerController extends Controller {
    constructor(host, options) {
        var _a, _b, _c, _d, _e;
        super(host);
        this.host = host;
        this.options = options;
        this.hoverController = new PointerHoverController(this.host, {
            target: (_a = this.options) === null || _a === void 0 ? void 0 : _a.target,
            handleHoverChange: (_b = this.options) === null || _b === void 0 ? void 0 : _b.handleHoverChange
        });
        this.pressController = new PointerPressController(this.host, {
            target: (_c = this.options) === null || _c === void 0 ? void 0 : _c.target,
            handlePressChange: (_d = this.options) === null || _d === void 0 ? void 0 : _d.handlePressChange
        });
        this.typeController = new PointerTypeController(this.host, {
            handleTypeChange: (_e = this.options) === null || _e === void 0 ? void 0 : _e.handleTypeChange
        });
    }
    get hover() { return this.hoverController.hover; }
    get press() { return this.pressController.press; }
    get type() { return this.typeController.type; }
}
