import { Controller, EventListenerController, EventListenerTarget, ReactiveElement } from '@a11d/lit';
import { ResizeController } from '@3mo/resize-observer';
export interface PointerHoverControllerOptions {
    target?: EventListenerTarget;
    handleHoverChange?(hover: boolean): void;
}
export declare class PointerHoverController extends Controller {
    protected readonly host: ReactiveElement;
    protected readonly options?: PointerHoverControllerOptions | undefined;
    protected _hover: boolean;
    get hover(): boolean;
    private readonly throttler;
    constructor(host: ReactiveElement, options?: PointerHoverControllerOptions | undefined);
    protected checkHover(): Promise<void>;
    protected readonly pointerEnter: EventListenerController;
    protected readonly pointerLeave: EventListenerController;
    protected readonly resizeController: ResizeController<Promise<void>>;
    protected readonly pointerDown: EventListenerController;
    protected readonly pointerUp: EventListenerController;
    protected readonly pointerCancel: EventListenerController;
}
//# sourceMappingURL=PointerHoverController.d.ts.map