import { Controller } from '@a11d/lit';
export class PointerTypeController extends Controller {
    constructor(host, options) {
        super(host);
        this.host = host;
        this.options = options;
    }
    hostConnected() {
        PointerTypeController.events.forEach(type => document.addEventListener(type, this));
    }
    hostDisconnected() {
        PointerTypeController.events.forEach(type => document.removeEventListener(type, this));
    }
    handleEvent(e) {
        switch (e.pointerType) {
            case 2:
            case 'touch':
                return this.type = 'touch';
            case 3:
            case 'pen':
                return this.type = 'pen';
            default:
                return this.type = 'mouse';
        }
    }
    get type() { var _a; return (_a = this._type) !== null && _a !== void 0 ? _a : (window.matchMedia('(pointer: coarse)').matches ? 'touch' : 'mouse'); }
    set type(type) {
        var _a, _b;
        if (type !== this._type) {
            this._type = type;
            (_b = (_a = this.options) === null || _a === void 0 ? void 0 : _a.handleTypeChange) === null || _b === void 0 ? void 0 : _b.call(_a, type);
            this.host.requestUpdate();
        }
    }
}
PointerTypeController.events = ['pointerdown', 'pointermove', 'pointerup', 'pointercancel'];
